# READ ME
This package allows to reproduce the experiments results available at doi.org/10.0.20.161/zenodo.5824264, cited in the paper *Zone extrapolations in parametric timed automata*

## Author
Artifact packaged by
Johan Arcile (Université de Lorraine, France)


## What does this package contain?

### A binary of IMITATOR
Build: feature/extra/9a97acf

Source can be downloaded at https://github.com/imitator-model-checker/imitator/commit/9a97acfdb9d61d48d0c0a01f9ce84e614850aff6

This binary is compiled for a Linux system (64 bits), and is standalone (no dependencies).


### Models and properties
In `models`

### Three "box" folders
In `boxNo`, `boxM` and `boxLU`

Those folders contain the set of queries to be executed with the adequate option of IMITATOR (no extrapolation, M-extrapolation, LU-extrapolation).
They also contain Python code to automatically execute those queries, store the results in a `.csv` file and write an `.html` file based on the results stored in the `.csv` file.

### A .css file
This is the CSS for the `.html` results files

### A script
This script automatizes the reproduction of the results

### No expected results
This artifact does *not* contain the expected results.


## How to reproduce the results ?

### System requirement

The script must be run on a Linux distribution with Python3 installed


**IMPORTANT: all folders on the absolute path to the artifact folder must be named without special characters (this notably excludes spaces)**


### Run the script
To run IMITATOR with the M-exploration, LU-extrapolation and without any extrapolation on the benchmark of models, simply execute `script.sh`.
To do so, open a terminal in this folder and execute the following command line:
```
./script.sh
```

Execution time is expected to be of about 100 hours.


### Partial reproduction

Alternatively, it is possible to run the experiments with a timeout of 1 second, instead of the timeout of 3600 seconds used in our experiments results. To do so instead run `./script-1s.sh`
This will return a (very) partial result, as all queries taking more than 1 second will be considered timeout, but expected execution time is less than 10 minutes in this case.

If one wishes to manually modify this timeout value, proceed as follow :
1. In `BoxNo/scripts/params1.py`, modify the numerical value line 26;
2. Repeat for `BoxM` and `BoxLU`;
3. Run `./script-1s.sh;`

## How to read the results ?

The script will generate three .html files:
* In `results_no_extrapolation.html` are the results for running the benchmark without extrapolation
* In `results_M-extrapolation.html` are the results for running the benchmark with the M-extrapolation
* In `results_LU-extrapolation.html` are the results for running the benchmark with the LU-extrapolation

Full result files are generated in the subdirectories of `boxNo/files/res` (and similarly for `boxM` and `boxLU`)

